#!/usr/bin/perl
#
# Copyright (c)2010-2011 Roman Bartke.  All rights reserved.
# Author: Dipl.-Inform. Roman Bartke
#
# Created: 2010-05-29
# Updated: 2011-11-20
#

my $lower = 0;

my($result, %opt) = Getopts('?hl');
$argcnt = $#ARGV + 1; 
if ((!$result) || defined($opt{'h'}) || defined($opt{'?'}) || ($argcnt != 2))
{
	print STDERR "usage: $0 [-l] [inputFile] [outputFile]\n";
	print STDERR "           -l: lower case\n";
  	exit;
}
 
$lower = 1 if defined($opt{'l'});

#if ($lower) {
#		print STDERR "mode: lower case\n";
#}
#else
#{
#		print STDERR "mode: upper case\n";
#}


$inFileName = $ARGV[0];
$outFileName = $ARGV[1];

#print $inFileName,"\n";
#print $outFileName,"\n";

#exit;

$in = read_input();
#print $in,"\n";
$out = chr(0xff).chr(0xfe); # unicode header

for($i=0; $i<length($in); $i++)
{
	my $c = substr($in,$i,1);
	if (($c ne chr(13)) && ($c ne chr(10)))
	{
		my $a = ord($c);
		if ($a >= 0x00 && $a <= 0x1f)
		{
			$d = 128;
		}
		elsif ($a >= 0x20 && $a <= 0x3f)
		{
			$d =   0;
		}
		elsif ($a >= 0x40 && $a <= 0x5f)
		{
			$d = -64;
		}
		elsif ($a >= 0x60 && $a <= 0x7f)
		{
			$d = -32;
		}
		elsif ($a >= 0x80 && $a <= 0x9f)
		{
			$d =  64;
		}
		elsif ($a >= 0xa0 && $a <= 0xbf)
		{
			$d = -64;
		}
		elsif ($a >= 0xc0 && $a <= 0xdf)
		{
			$d =-128;
		}
		elsif ($a >= 0xe0 && $a <= 0xfe)
		{
			$d =-128;
		}
		elsif ($a == 0xff)
		{
			$d =-161;
		}
		else
		{
			die "unknown char code";
		}
		$c = chr(ord($c) + $d);
		if (!$lower) 
		{
			$out .= $c . chr(0xe0);
		}
		else
		{
			$out .= $c . chr(0xe1);
		}
	}
	else
	{
		$out .= $c . chr(0);
	}
}
open(OUT, "> $outFileName");
binmode(OUT);
print OUT $out;
close(OUT);

sub read_input {
        die if !open(FILE, "$inFileName");
	binmode(FILE);
	
	my $inFile = "";
        while (<FILE>) {
			my $line = $_;
			$line =~ s/^\s+([0-9]+)/\1/;
			$inFile .= $line;
        }
        close (FILE);
	return $inFile;
}

sub Getopts 
{
  my($argumentative) = @_;
  my(@args,$first,$rest);
  my($errs) = 0;
  my(%opt) = ();
  local($[) = 0;
  local($_);
  
  @args = split( / */, $argumentative );
  while(@ARGV && ($_ = $ARGV[0]) =~ /^-(.)(.*)/) {
    ($first,$rest) = ($1,$2);
    my $pos = index($argumentative,$first);
    if($pos >= $[) {
      if($args[$pos+1] eq ':') {
	shift(@ARGV);
	if($rest eq '') {
	  ++$errs unless @ARGV;
	  $rest = shift(@ARGV);
	}
	$opt{$first} = $rest;
      }
      else {
	$opt{$first} = 1;
	if($rest eq '') {
	  shift(@ARGV);
	}
	else {
	  $ARGV[0] = "-$rest";
	}
      }
    }
    else {
      print STDERR "Unknown option: $first\n";
      ++$errs;
      if($rest ne '') {
	$ARGV[0] = "-$rest";
      }
      else {
	shift(@ARGV);
      }
    }
  }
  return($errs == 0, %opt);
}


# vim:ts=4
