; vim:ts=8:sw=8:sta:et:sts=8:ai:syn=a65
.list on
.listbytes unlimited
.debuginfo +

; ----------------------------------------------------------------------------
; JSF V1.2 - Der Bankmanager fuer den C128
; Jimm: JSR fuer Fremdbank
; Simm: STASH fuer Fremdbank
; Fimm: FETCH fuer Fremdbank
; - Bank: 0 / Adresse: $0d00-$0d75 (Common)
; - Programmierer: Sven Friedrichs
; - Entstehungszeitraum: Februar 1996
; - Notiz: Macht JSF schneller und kuerzer!
; ----------------------------------------------------------------------------
;LoadAddress = $0d00

        .segment "JSF"

zR8502      = $01
zPC         = $03
zAREG       = $06
zXREG       = $07
zYREG       = $08
zIMPARM     = $CE
STACK       = $0100
JSRFAR      = $02CD
FARVEC      = JSRFAR+$11
MMUCR       = $FF00

        .global JSF_START, JSF_END

JSF_START:
        .export jimm,simm,fimm,JSFRTS

;jimm     = $0d00
;simm     = $0d03
;fimm     = $0d06
JSFRTS   = $0d74                       ; position of RTS in JSF

        .org $0D00

; ----------------------------------------------------------------------------
; JIMM (JSR IMMediate)
jimm:
JIMM:				  ; PC <- Address
      	  JMP	  JIMM1
; ----------------------------------------------------------------------------
; SIMM (Stash	IMMediate)
simm:
SIMM:				  ; PC <- Address
      	  JMP	  SIMM1

; ----------------------------------------------------------------------------
; FIMM (Fetch	IMMediate)
fimm:
FIMM:
     	  PHP
      	  STA	  zAREG		  ; sichere akku
      	  LDA	  #$FF		  ; A <- M
      	  BNE	  IMMROUTINE	  ; if Z=0, PC = PC + offset

JIMM1:
      	  PHP			  ; sichere status-reg
      	  STA	  zAREG		  ; sichere akku
      	  LDA	  #0		  ; A <- M
      	  BEQ	  IMMROUTINE	  ; if Z=1, PC = PC + offset

SIMM1:
     	  PHP			  ; sichere status-reg
      	  STA	  zAREG		  ; sichere akku
      	  LDA	  #1		  ; A <- M

IMMROUTINE:
      				  ; RAM:0D12^j
      	  PHA			  ; sichere routinen-wahl
      	  STX	  zXREG		  ; uebergebe x-register
      	  STY	  zYREG		  ; uebergebe y-register
;
; ! Achtung +2 nur deshalb, weil 2 weitere stapelbefehle (PHP, PHA)
;   bereits oben erfolgt sind.
;
      	  TSX			  ; stapelzeiger ins x-register
     	  LDA	  STACK+1 + 2,X	  ; jsr-adresse	als zeropage-pointer
      	  STA	  zIMPARM	  ; M <- (A)

     	  LDA	  STACK+2 + 2,X	  ; A <- M
      	  STA	  zIMPARM+1	  ; M <- (A)

      	  LDY	  #3		  ; Y <- M
IMMROUTINE1:
      	  LDA	  (zIMPARM),Y	  ; lese daten nach befehl:
      	  STA	  zR8502,Y	  ; 1. konfiguration-byte   ($02)
     	  INC	  STACK+1 + 2,X	  ; 2. highbyte	der adresse ($03)
      	  BNE	  IMMROUTINE2	  ; 3. lowbyte der adresse  ($04)
     	  INC	  STACK+2 + 2,X	  ; M <- (M) + 1
IMMROUTINE2:
      	  DEY			  ; Y <- (Y) - 1
      	  BNE	  IMMROUTINE1	  ; if Z=0, PC = PC + offset

      	  STA	  MMUCR		  ; konfiguration aktivieren!
      	  PLA			  ; A <- (Stack)
      	  BMI	  FIMMSUB	  ; if N=1, PC = PC + offset
      	  BNE	  SIMMSUB	  ; if Z=0, PC = PC + offset
      	  PLA			  ; A <- (Stack)
      	  JSR	  JIMMSUB	  ; Stack <- PC, PC <- Address
      	  JMP	  CRRESET	  ; PC <- Address

; =============== S U B R O U T I N E ========================================


JIMMSUB:
      	  TAX			  ; status vom akku ins	x-reg

JIMMSUB1:
      	  LDA	  zPC,Y		  ; sichere adresse (low+high)
      	  PHA			  ; Stack <- (A)
      	  INY			  ; Y <- (Y) + 1
      	  CPY	  #2		  ; (Y - M) -> NZC
      	  BNE	  JIMMSUB1	  ; if Z=0, PC = PC + offset
      	  TXA			  ; status vom x-reg in	akku, dann stack
      	  PHA			  ; Stack <- (A)
      	  LDA	  zAREG		  ; A <- M
      	  LDX	  zXREG		  ; X <- M
      	  LDY	  zYREG		  ; Y <- M
      	  RTI			  ; sprung ausfhren!
; End	of function JIMMSUB

; ----------------------------------------------------------------------------

SIMMSUB:			
      	  PLA			  ; A <- (Stack)
      	  LDA	  zAREG		  ; A <- M
      	  STA	  (zPC),Y	  ; = $03
      	  CLC			  ; C <- 0
      	  BCC	  FIMMSUB1	  ; if C=0, PC = PC + offset

FIMMSUB:			
      	  PLA			  ; A <- (Stack)
      	  LDA	  (zPC),Y	  ; = $03

FIMMSUB1:			  ; gesicherte Registerinhalte holen
      	  LDX	  zXREG		  ; X <- M
      	  LDY	  zYREG		  ; Y <- M

CRRESET:			  ; Rckkehrbank setzen und Rcksprung
      	  PHA			  ; Stack <- (A)
      	  LDA	  FARVEC          ; JSRFAR+$11
      	  STA     MMUCR		  ; MMU	8722 Config. Reg. (Copy)
      	  PLA			  ; A <- (Stack)
      	  RTS			  ; PC <- (Stack)

        .reloc
JSF_END:
