.ifdef C128
.include "jsf.i"
.endif

.ifdef C64
; =====================================
; C64 defines
; =====================================
.ifdef WithSAVELOAD
zSTATUS                        =   $90 ; I/O operation status byte
.endif
zVERCK                         =   $93 ; load or verify flag

zXSAV                          =   $97 ; temp for BASIN
zLDTND                         =   $98 ; index for logical file

zDFLTN                         =   $99 ; default input device #
zDFLTO                         =   $9A ; default output device #

zPTR1                          =   $9E ; cassette error pass1

zLA                            =   $B8 ; current file logical addr
zSA                            =   $B9 ; current file 2nd addr
zFA                            =   $BA ; current file primary addr (first addr)

.ifdef WithSAVELOAD
zMEMUSS                        =   $C3 ; cassette load temps (2 bytes)
zSAL                           =   $AC ; addr for load/save low
zSAH                           =   $AD ; addr for load/save high
zEAL                           =   $AE ; end addr load/save low
zEAH                           =   $AF ; end addr load/save high
.endif

lLAT                           = $0259 ; logical file numbers (address table)
lFAT                           = $0263 ; primary device numbers
lSAT                           = $026D ; secondary addresses

lIOPEN                         = $031A ; kernal/os indirects for code
lICLOSE                        = $031C
lICHKIN                        = $031E
lICKOUT                        = $0320
lICLRCH                        = $0322
lIBASIN                        = $0324
lIBSOUT                        = $0326
lIGETIN                        = $032A
.ifdef WithSAVELOAD
lILOAD                         = $0330
lISAVE                         = $0332
.endif

kLOOKUP                        = $F30F ; find file in Logical File Table
kJLTLK                         = $F314 ; kLOOKUP entry (find log file number)
kJZ100                         = $F31F ; routine to fetch table entries

.ifdef WithSAVELOAD
kLUKING                        = $F5AF ; print "searching for <name>"
kLODING                        = $F5D2 ; print "loading..."
kBREAK                         = $F633 ; stop key pressed
kSAVING                        = $F68F ; print "saving"
.endif

kERROR1                        = $F6FB ; ERROR 1 "too many files"
kERROR2                        = $F6FE ; ERROR 2 "file open"
kERROR3                        = $F701 ; ERROR 3 "file not open"
.ifdef WithSAVELOAD
kERROR4                        = $F704 ; ERROR 4 "file not found"
.endif
kERROR6                        = $F70A ; ERROR 6 "not input file"

.ifdef WithSAVELOAD
kRD300                         = $FB8E ; restore starting address
kCMPSTE                        = $FCD1 ; compare start to end
kINCSAL                        = $FCDB ; increment current addr.
.endif

kUDST                          = $FE1C ; update status

kBSOUT                         = $FFD2 ; output to channel

.ifdef WithSAVELOAD
kSTOP                          = $FFE1 ; stop key?
.endif

; -------------------------------------
; direct entry points into system routines (C64)
; N-prefix stands for normal 
; -------------------------------------
NOPEN1                         = $F372

NCLOSE1                        = $F29D
NCLOSE2                        = $F2F1

NCHKIN1                        = $F219
NCHKIN2                        = $F22A

NCHKOUT1                       = $F25B
NCHKOUT2                       = $F26F

NBASIN                         = $F157

NBSOUT                         = $F1CA
;NBSOUT1                        = $F1F1
;NBSOUT2                        = $F1F8

BASIN                          = $FFCF
NGETIN                         = $F13E

.ifdef WithSAVELOAD
NLOAD1                         = $F4AB
NLOAD2                         = $F5A9

NSAVE1                         = $F5ED
.endif

.else

.ifdef C128
; =====================================
; C128 defines
; =====================================
.ifdef WithSAVELOAD
zSTATUS                        =   $90 ; I/O operation status byte
.endif
zSVXT                          =   $92 ; temporary / Kassette Timing-Konstante

zVERCK                         =   $93 ; load or verify flag

zXSAV                          =   $97 ; temp for BASIN
zLDTND                         =   $98 ; index for logical file

zDFLTN                         =   $99 ; default input device #
zDFLTO                         =   $9A ; default output device #

zPTR1                          =   $9E ; cassette error pass1
 
.ifdef WithSAVELOAD
zSAL                           =   $AC ; addr for load/save low
zSAH                           =   $AD ; addr for load/save high
zEAL                           =   $AE ; end addr load/save low
zEAH                           =   $AF ; end addr load/save high
.endif
                                                                              
zLA                            =   $B8 ; current file logical addr
zSA                            =   $B9 ; current file 2nd addr
zFA                            =   $BA ; current file primary addr (first addr)
 
.ifdef WithSAVELOAD
zMEMUSS                        =   $C3 ; cassette load temps (2 bytes)
.endif

lLAT                           = $0362 ; logical file numbers (address table)
lFAT                           = $036C ; primary device numbers
lSAT                           = $0376 ; secondary addresses
                                                                               
lIOPEN                         = $031A ; kernal/os indirects for code
lICLOSE                        = $031C
lICHKIN                        = $031E
lICKOUT                        = $0320
lICLRCH                        = $0322
lIBASIN                        = $0324
lIBSOUT                        = $0326
lIGETIN                        = $032A
.ifdef WithSAVELOAD
lILOAD                         = $0330
lISAVE                         = $0332
.endif

.ifdef WithSAVELOAD
kRD300                         = $ED51 ; restore starting address
kCMPSTE                        = $EEB7 ; compare start to end
kINCSAL                        = $EEC1 ; increment current addr.
.endif

kLOOKUP                        = $F202 ; find file in Logical File Table
                                       ; LFN in X-Reg in LFN Tabelle suchen
kJLTLK                         = $F207 ; kLOOKUP entry (find log file number)
kJZ100                         = $F212 ; routine to fetch table entries

.ifdef WithSAVELOAD
kLUKING                        = $F50F ; print "searching for <name>"
kLODING                        = $F533 ; print "loading..."
kBREAK                         = $F5B5 ; stop key pressed
kSAVING                        = $F5BC ; print "saving"
.endif

kERROR1                        = $F67C ; ERROR 1 "too many files"
kERROR2                        = $F67F ; ERROR 2 "file open"
kERROR3                        = $F682 ; ERROR 3 "file not open"
.ifdef WithSAVELOAD
kERROR4                        = $F685 ; ERROR 4 "file not found"
.endif
kERROR6                        = $F68B ; ERROR 6 "not input file"

kUDST                          = $F757 ; update status

kBSOUT                         = $FFD2 ; output to channel

.ifdef WithSAVELOAD
kSTOP                          = $FFE1 ; stop key?
.endif

; -------------------------------------
; direct entry points into system routines (C128)
; -------------------------------------
NOPEN1                         = $EFDA

NCLOSE1                        = $F194
NCLOSE2                        = $F1E4

NCHKIN1                        = $F10B
NCHKIN2                        = $F11D

NCHKOUT1                       = $F151
NCHKOUT2                       = $F163

NBASIN                         = $EF06

NBSOUT                         = $EF79
;NBSOUT1                        = $F1F1
;NBSOUT2                        = $F1F8

BASIN                          = $FFCF
NGETIN                         = $EEEB

.ifdef WithSAVELOAD
NLOAD1                         = $F272
NLOAD2                         = $F39B

NSAVE1                         = $F54E
.endif

.endif
.endif
