
; vim:ts=8:sw=8:sta:et:sts=8:ai:syn=a65

.list on
.listbytes unlimited
.debuginfo +

;LoadAddress = $0c00

        .segment "TRANSFER"

        .globalzp to,tol,toh,tob
        .globalzp t1,t1l,t1h,t1b
        .globalzp t2,t2l,t2h,t2b
        .global   temps
; ----------------------------------------------------------------------------

to        =    $60                     ; transfer to
tol       =    $60                     ; Dest-Lo
toh       =    $61                     ; Dest-Hi
tob       =    $62                     ; Dest-Bank

t1        =    $63                     ; transfer param 1
t1l       =    $63                     ; Length-Lo
t1h       =    $64                     ; Length-Hi
t1b       =    $65                     ; 0

t2        =    $66                     ; transfer param 2
t2l       =    $66                     ; Source-Lo
t2h       =    $67                     ; Source-Hi
t2b       =    $68                     ; Source-Bank

stashx    =    $02b9                   ; STAVEC

temps     =    $0ab7                   ; temporary storage
direct    =    $0ab3                   ; direction of transfer

sxreg     =    $0aaf                   ; Rettungsbyte fr X-Register

;fetch     =    $b11a

kistav    =    $ff77

        .GLOBAL transfer

transfer:
          lda #0
          sta direct
trns02:
	  sec
          lda t2
          sbc to
          lda t2+1
          sbc to+1
          bcs trns04
          lda t1
          adc to
          sta to
          lda t1+1
          adc to+1
          sta to+1
          lda t1+2
          adc to+2
          sta to+2

          ldx #2
trns03:
          lda temps,x
          sta t2,x
          dex
          bpl trns03

          lda #$80
          sta direct
trns04:
          ldy #0

; ein Byte kopieren
trns05:
          JSR fetch
          ldx #to
          stx stashx
          ldx to+2
          sei
          JSR kistav
          cli
          bit direct
          bmi trns09
          inc to
          bne trns10
          inc to+1
          bne trns10

;         jmp error
          brk

; Adresse bei Rckwrtskopierung vermindern
trns09:   jsr decto
          jsr dect2
          jmp trns11
trns10:   jsr inct2

; Anzahl Bytes vermindern
trns11:   jsr dect1
          bcs trns05
          rts


; Adresse um 1 vermindern
decto:
          lda #1

; Adresse um .A vermindern
subto:
          sta sxreg
          sec
          lda to
          sbc sxreg
          sta to
          lda to+1
          sbc #0
          sta to+1
          lda to+2
          sbc #0
          sta to+2
          rts

; Hilfszeiger um 1 vermindern
dect1:
          sec
          lda t1
          sbc #1
          sta t1
          lda t1+1
          sbc #0
          sta t1+1
          lda t1+2
          sbc #0
          sta t1+2
          rts

; Zeiger um 1 erhhen
inct2:
          lda #1

; Zeiger um .A erhhen
addt2:
          clc
          adc t2
          sta t2
          bcc addt2x
          inc t2+1
          bne addt2x
          inc t2+2
addt2x:
          rts

; Aktuelle Adresse um 1 vermindern
dect2:
          sec
          lda t2
          sbc #1
          sta t2
          lda t2+1
          sbc #0
          sta t2+1
          lda t2+2
          sbc #0
          sta t2+2
          rts

fetch:                                 ; intern s. 203
        stx $0ab2
        ldx $68
        lda #$66
        sei
        jsr $FF74
        cli
        ldx $0ab2
        rts

.ifdef NIXDA
totot2:
        lda to
        sta t2
        lda to+1
        sta t2+1
        lda to+2
        sta t2+2
        rts

subom2:
        sec
        lda to
        sbc t2
        sta to
        lda to+1
        sbc t2+1
        sta to+1
        lda to+2
        sbc t2+2
        sta to+2
        rts

range:  bcs ranger
        jsr totot2
        clc
        lda to
        sta temps
        lda to+1
        sta temps+1
        lda to+2
        sta temps+2
        jsr subom2
        lda to
        sta t1
        lda to+1
        sta t1+1
        lda to+2
        sta t1+2
        bcc ranger
        clc
        .byte $24                      ; skip1
ranger: sec
        rts
.endif

.ifdef UNUSED
        .global TransEx
        .import jimm,simm,fimm

JSRFAR    = $02CD
FARVEC    = JSRFAR+$11
MMUCR    = $FF00

FetchFrom:
        SEI
        LDA t2b
        STA MD1F+0

        LDA t2
        STA MD1F+1
        LDA t2+1
        STA MD1F+2

        LDA MMUCR
        STA FARVEC
        JSR fimm
MD1F:   .byte $00,$00,$00
        CLI
        RTS

StoreTo:
        SEI
        PHA
        LDA tob
        STA MD1S+0

        LDA to
        STA MD1S+1
        LDA to+1
        STA MD1S+2
        
        LDA MMUCR
        STA FARVEC
        PLA
        JSR simm
MD1S:   .byte $00,$00,$00
        CLI
        RTS


TransEx:
        LDA MMUCR
        STA FARVEC

          lda #0
          sta direct
;         clc
;         jsr range
;         bcs trnsx01
;         bcc trnsx02
;rnsx01:
;         brk
trnsx02:
	  sec
          lda t2
          sbc to
          lda t2+1
          sbc to+1
          bcs trnsx04
          lda t1
          adc to
          sta to
          lda t1+1
          adc to+1
          sta to+1
          lda t1+2
          adc to+2
          sta to+2

          ldx #2
trnsx03:
          lda temps,x
          sta t2,x
          dex
          bpl trnsx03

          lda #$80
          sta direct
trnsx04:
          ldy #0

; ein Byte kopieren
trnsx05:
          JSR FetchFrom
;         ldx #to
;         stx stashx
;         ldx to+2
          JSR StoreTo
          bit direct
          bmi trnsx09
          inc to
          bne trnsx10
          inc to+1
          bne trnsx10

;         jmp error
          brk

; Adresse bei Rckwrtskopierung vermindern
trnsx09:   jsr decto
          jsr dect2
          jmp trnsx11
trnsx10:   jsr inct2

; Anzahl Bytes vermindern
trnsx11:   jsr dect1
          bcs trnsx05
          rts
.endif
